#![allow(deprecated)]
use std::fmt;
use std::str;
/// Whether the gradient ramp spans one model or the whole scene.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum SpatialGradientExtents {
    #[serde(rename = "LOCAL")]
    Local,
    #[serde(rename = "GLOBAL")]
    Global,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl SpatialGradientExtents {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            SpatialGradientExtents::Local => "LOCAL",
            SpatialGradientExtents::Global => "GLOBAL",
            SpatialGradientExtents::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for SpatialGradientExtents {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for SpatialGradientExtents {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for SpatialGradientExtents {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<SpatialGradientExtents, conjure_object::plain::ParseEnumError> {
        match v {
            "LOCAL" => Ok(SpatialGradientExtents::Local),
            "GLOBAL" => Ok(SpatialGradientExtents::Global),
            v => v.parse().map(|v| SpatialGradientExtents::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for SpatialGradientExtents {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<SpatialGradientExtents, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the SpatialGradientExtents enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
